com.holonplatform.datastore.mongo.core.async

## Interface BaseAsyncMongoDatastore.Builder<D extends com.holonplatform.core.datastore.DatastoreOperations,TX extends MongoTransaction<com.mongodb.reactivestreams.client.ClientSession>,B extends BaseAsyncMongoDatastore.Builder<D,TX,B>>

- Type Parameters:
    `D` - `DatastoreOperations` type
    `TX` - Concrete transaction type
    `B` - Concrete builder type
  All Superinterfaces:
    com.holonplatform.core.datastore.DatastoreOperations.Builder<D,B>, com.holonplatform.core.ExpressionResolver.ExpressionResolverBuilder<B>, MongoDatastoreBuilder<D,com.mongodb.reactivestreams.client.ClientSession,TX,B>
  All Known Subinterfaces:
    AsyncMongoDatastore.Builder, ReactiveMongoDatastore.Builder
  All Known Implementing Classes:
    AbstractAsyncMongoDatastore.AsyncBuilder, DefaultAsyncMongoDatastore.DefaultBuilder, DefaultReactiveMongoDatastore.DefaultBuilder
  Enclosing interface:
    BaseAsyncMongoDatastore

      public static interface BaseAsyncMongoDatastore.Builder<D extends com.holonplatform.core.datastore.DatastoreOperations,TX extends MongoTransaction<com.mongodb.reactivestreams.client.ClientSession>,B extends BaseAsyncMongoDatastore.Builder<D,TX,B>>
      extends MongoDatastoreBuilder<D,com.mongodb.reactivestreams.client.ClientSession,TX,B>

  Base asynchronous Datastore builder.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `B` | `client(com.mongodb.reactivestreams.client.MongoClient client)` Set the `MongoClient` to use.
    `<C extends com.holonplatform.core.datastore.DatastoreCommodity> B` | `withCommodity(AsyncMongoDatastoreCommodityFactory<C> commodityFactory)` Register a `AsyncMongoDatastoreCommodityFactory`.

    - ### Methods inherited from interface com.holonplatform.datastore.mongo.core.MongoDatastoreBuilder

      `database, enumCodecStrategy, readConcern, readPreference, transactionFactory, withCodec, withCodecProvider, writeConcern`

    - ### Methods inherited from interface com.holonplatform.core.datastore.DatastoreOperations.Builder

      `build, configuration, dataContextId, traceEnabled`

    - ### Methods inherited from interface com.holonplatform.core.ExpressionResolver.ExpressionResolverBuilder

      `withExpressionResolver`

- - ### Method Detail

    - #### client

          B client(com.mongodb.reactivestreams.client.MongoClient client)

      Set the `MongoClient` to use.
      Parameters:
        `client` - MongoClient to set (not null)
      Returns:
        this

    - #### withCommodity

          <C extends com.holonplatform.core.datastore.DatastoreCommodity> B withCommodity(AsyncMongoDatastoreCommodityFactory<C> commodityFactory)

      Register a `AsyncMongoDatastoreCommodityFactory`.
      Type Parameters:
        `C` - Commodity type
      Parameters:
        `commodityFactory` - The factory to register (not null)
      Returns:
        this

Copyright © 2019 The Holon Platform. All rights reserved.